︠532af8d4-e8bc-4f1b-9931-222007e06a78i︠
%html
Here are some functions which compute the dual of a planar graph.  Currently, I don't think there is any error checking, and I don't remember if I decided that this implementation was correct or not.  However, the dual computed in the example below is correct.  I think that it works.

︡77ba0df8-8707-4e3e-9db2-8ce95e476d7d︡{"html": "Here are some functions which compute the dual of a planar graph.  Currently, I don't think there is any error checking, and I don't remember if I decided that this implementation was correct or not.  However, the dual computed in the example below is correct.  I think that it works."}︡
︠343e436e-7eec-45bb-b950-7e457a858f0e︠
def faces(g):
    d={}
    for key,val in g.get_embedding().iteritems():
        d[key]=dict(zip(val,val[1:]+[val[0]]))
    list_faces=[]
    for start in d:
        while d[start]:
            face=[]
            prev=start
            _,curr = d[start].popitem()
            face.append(start)
            while curr != start:
                face.append(curr)
                prev,curr = (curr, d[curr].pop(prev))
            list_faces.append(face)
    return list_faces

def graph_dual(g):
    f = [tuple(face) for face in faces(g)]
    f_edges = [tuple(zip(i,i[1:]+(i[0],))) for i in f]
    dual = Graph([f_edges,lambda f1,f2: set(f1).intersection([(e[1],e[0]) for e in f2])])
    return dual
︡8d5d4ce4-6ab5-44d6-bb00-d8fcbf116b2d︡︡
︠5333bbd1-0294-4191-9895-7fce79c79469︠
h=graphs.PathGraph(2)
g=h.disjoint_union(h).disjoint_union(h)
g=g.complement()
g.relabel()
show(g)
︡79f2dda3-09d9-4ce0-b90a-9735a13e9ffb︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠4ced7c9e-17c6-4e80-96f5-4a5cfdfb5866︠
g.is_planar(set_embedding=True, set_pos=True)
show(g)
︡818f261c-bdbe-4a8f-9572-ac09a9145459︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠83059edb-72ab-4dd0-b5fb-afc3df4c3eef︠
# The vertices forming the faces of the graph
faces(g)
︡49b9400e-d165-49be-9a61-fd8331dccf33︡{"stdout": "[[0, 5, 2], [0, 4, 3], [0, 2, 4], [0, 3, 5], [1, 4, 2], [1, 5, 3], [1, 3, 4], [1, 2, 5]]"}︡
︠c13dc32d-3682-4015-829a-235e9c51fe9a︠
dual_g=graph_dual(g)
︡10a9d084-a0fa-42c0-a012-33eb1b46ab12︡︡
︠a1b35eb0-c2a4-4fb7-9e62-e8284b4faf4c︠
# Each vertex is labeled with the edges of the face that it represents.
show(dual_g)
︡da56df68-df57-479d-807a-add7badb7b9c︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠935801e3-44ef-4b07-8bee-f27cc81b3aa2︠
# We can relabel the vertices to get a "nice" graph, but then we lose the information about which face corresponds to which vertex.
dual_g.relabel()
show(dual_g)
︡6286e432-97f2-4a8a-bdc3-d01160152821︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
